RealRoots fails on -x^2
Status: Closed Start date: 25 Sep 2019

Priority: Urgent Due date:  

Assignee: John Abbott % Done: 100%

Category: bug Estimated time: 0.67 hour

Target version: CoCoA-5.3.0 Spent time: 0.65 hour

Description

Small failing example:

>>> RealRoots(-x^2);

--> ERROR: The arg(s) given are unsuitable

--> [CoCoALib] FloorLogBase: cannot compute log(0)

--> WHERE: at line 104 (column 13) of RealRoots.cpkg5

-->   B := 2^(1+FloorLog2(RootBound(F)));

-->             ^^^^^^^^^^^^^^^^^^^^^^^

CONTEXT: function RealRoots2 at line 104 of RealRoots.cpkg5

 CALLED BY: function RealRoots at line 85 of RealRoots.cpkg5

  called at top-level

History

#1 - 26 Sep 2019 16:46 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

I thought I had already fixed this bug.  Indeed the code is there inside RealRoots2; the code assumed that the arg to RealRoots2 is square-free, but

this appears not to be the case.  Why?  :-/

#2 - 29 Sep 2019 21:57 - John Abbott

- Status changed from In Progress to Feedback

- Assignee set to John Abbott

- % Done changed from 10 to 90

Indeed I had "fixed" it, but there was a slight mistake: I forgot to guarantee that the LC of the poly handed to the internal function RealRoots2 is

positive.  Now RealRoots handles this correctly.

I hope Anna can check that the corrected package RealRoots.ckg5 works for her too.  Then we can close (and tell the finder that the bug has been

fixed).  Perhaps the corrected package should be sent to him?

#3 - 01 Oct 2019 14:11 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 0.67 h

I have added RealRoots(-x^2) to the exbugs test suite.

Closing.
